//------------------------------------------------------
// Name: Graf.h
// Desc: szomszdossgi mtrixxal megvalstott grf
//		 ez a megvalsts irnytott mtrixot hasznl
//		 az irnytatlan mtrix csak az add illetve a 
//		 remove eljrsokat vltoztatja
// (c) RebelMaGE, 2004
//------------------------------------------------------
#include "Graf.h"
//------------------------------------------------------
// Name: Graf
// Desc: konstruktor
//------------------------------------------------------
Graf::Graf(short size){
	if (size < 0) return;
	m_size = size;
	m_matrix = new short*[m_size];
	for (int i = 0; i < m_size; i++){
		m_matrix[i] = new short[m_size];
		for (int j = 0; j < m_size; j++)
			m_matrix[i][j] = 0;
	}
}
//------------------------------------------------------
// Name: Graf
// Desc: kopi konstruktor
//		 (!) kopi konstruktorra mrpedig szksg VAN
//		 klnben jesjjel el fog szllni az egsz 
//		 cucc a destruktornl... (!)
//------------------------------------------------------
Graf::Graf(const Graf& g){
	
	m_size = g.m_size;
	m_matrix = new short*[m_size];
	for (int i = 0; i < m_size; i++){
		m_matrix[i] = new short[m_size];
		for (int j = 0; j < m_size; j++)
			m_matrix[i][j] = g.m_matrix[i][j];
	}		
}
//------------------------------------------------------
// Name: ~Graf
// Desc: destruktor
//------------------------------------------------------
Graf::~Graf(){
	if (!m_size) return;
	m_size = 0;
	for (UINT i = 0; i < m_size; i ++){
		if (m_matrix[i]) delete m_matrix[i];

	}		
	if (m_matrix)	delete m_matrix;
	m_matrix = NULL;
}
//------------------------------------------------------
// Name: add
// Desc: egy pont hozzadsa
//------------------------------------------------------
void Graf::add(UINT i, UINT j){
	m_matrix[i][j] = 1;
	//m_matrix[j][i] = 1;		// ha irnytatlan
}
//------------------------------------------------------
// Name: remove
// Desc: egy elem eltvoltsa
//------------------------------------------------------
void Graf::remove(UINT i, UINT j){
	m_matrix[i][j] = 0;
	//m_matrix[j][i] = 1;		// ha irnytatlan
}
//------------------------------------------------------
// Name: operator+
// Desc: kt grf nija
//------------------------------------------------------
Graf Graf::operator+(const Graf g){
	Graf retVal(m_size);
	for (UINT i = 0; i < m_size; i++){
		for (UINT j = 0; j < m_size; j++){
			if (m_matrix[i][j] == 1 ||g.m_matrix[i][j] == 1)
				retVal.m_matrix[i][j] = 1;
		}
	}
	return retVal;
}
//------------------------------------------------------
// Name: operator*
// Desc: kt grf metszete
//------------------------------------------------------
Graf Graf::operator*(const Graf g){
	Graf retVal(m_size);
	for (UINT i = 0; i < m_size; i++){
		for (UINT j = 0; j < m_size; j++){
			if (m_matrix[i][j] == 1 &&g.m_matrix[i][j] == 1)
				retVal.m_matrix[i][j] = 1;
		}
	}
	return retVal;
}	
//------------------------------------------------------
// Name: echoNearest
// Desc: adott pontba s adott pontbl lek listzsa
//------------------------------------------------------
void Graf::echoNearest(const short csucs){
	cout << "honnan: ";
	for (UINT i = 0; i < m_size; i++){
		if (m_matrix[i][csucs] == 1) cout << i << " ";
	}
	cout << endl;
	cout << "hova: ";
	for (UINT j = 0; j < m_size; j++){
		if (m_matrix[csucs][j] == 1) cout << j << " ";
	}
}
//------------------------------------------------------
// Name: operator<<
// Desc: kiirs (friend)
//------------------------------------------------------
ostream& operator<<(ostream& out, const Graf g){
	out << endl << " ->\t";
	for (UINT i = 0; i <g.m_size; i++){
		out << i << ((i < 10)?"  ":" ");
	}
	out << endl;
	for (UINT i = 0; i < g.m_size; i++){
		out << i << "\t";
		for (UINT j = 0; j < g.m_size; j++){
			out << ((g.m_matrix[i][j] == 1)? "x" : " " ) << "  ";
		}
		out << endl;
	}
	return out;
}