//------------------------------------------------------
// Name: LongNum.cpp
// Desc: hossz decimlis szm trolsra szolgl oszt
// (c) RebelMaGE, 2004
//------------------------------------------------------
#include "LongNum.h"
//------------------------------------------------------
// Name: LongNum
// Desc: konstruktor
//------------------------------------------------------
LongNum::LongNum(){
	m_szam = new char[LEN];
	strcpy(m_szam, "0");

	m_scl = new char[LEN];
	strcpy(m_scl, "0123456789");
}
//------------------------------------------------------
// Name: LongNum
// Desc: konstruktor
//------------------------------------------------------
LongNum::LongNum(char* szam){
	m_szam = new char[LEN];
	strcpy(m_szam, szam);

	m_scl = new char[LEN];
	strcpy(m_scl, "0123456789");
}
//------------------------------------------------------
// Name: LongNum
// Desc: kopi konstruktor
//------------------------------------------------------
LongNum::LongNum(const LongNum& ln){
	m_szam = new char[LEN];
	strcpy(m_szam, ln.m_szam);

	m_scl = new char[LEN];
	strcpy(m_scl, ln.m_scl);
}
//------------------------------------------------------
// Name: ~LongNum
// Desc: destruktor
//------------------------------------------------------
LongNum::~LongNum(){
	if (m_szam) delete m_szam;
	m_szam = NULL;

	if (m_scl) delete m_scl;
	m_scl = NULL;
}
//------------------------------------------------------
// Name: operator+
// Desc: sszead
//------------------------------------------------------
LongNum LongNum::operator+(const LongNum& ln){
		//
		// (!) MAJOR WARNING (!)
		//		Longnum& operator+ () NOT ALLOWED
		//		'cause: return value will be destructed before
		//				value really returns and permanently
		//				return the destructed value 
		//				(it takes ~30 minutes to detect this issue)
		//
	char* ret = new char[LEN];
	char* s1  = new char[LEN];
	char* s2  = new char[LEN];

	strcpy(s1, m_szam);
	strcpy(s2, ln.m_szam);
	strcpy(ret, "");
	strrev(s1);
	strrev(s2);
	if (strlen(s1) > strlen(s2)){

		while (strlen(s1) > strlen(s2)){
			strcat(s2, "0");
		}

	}
	if (strlen(s1) < strlen(s2)){

		while (strlen(s1) < strlen(s2)){
			strcat(s1, "0");
		}

	}


	int carry = 0;

	for (unsigned i = 0; i < strlen(s1); i++){
		int poz1 = 0;
		poz1 = (int)strchr( m_scl, (char)s1[i]);
		if (poz1 == NULL) {
			cout << endl << "hibs karakter" << endl;
			break;
		}
		poz1 -= (int)m_scl;
		int poz2 = (int)strchr( m_scl, (char)s2[i]); 
		if (poz2 == NULL) {
			cout << endl << "hibs karakter" << endl;
			break;
		}
		poz2 -= (int)m_scl;

		carry = carry + poz1 + poz2;

		strncat(ret, &m_scl[carry % strlen(m_scl)], 1);

		carry = carry / strlen(m_scl);
		
	}

	if (carry == 1 && strlen(ret) < LEN - 1)
		strcat(ret,"1");


	delete s1;
	delete s2;

	strrev(ret);

	return LongNum(ret);
}


//------------------------------------------------------
// Name: operator-
// Desc: kivon
//------------------------------------------------------
LongNum LongNum::operator-(const LongNum& ln){
		//
		// (!) MAJOR WARNING (!)
		//		Longnum& operator+ () NOT ALLOWED
		//		'cause: return value will be destructed before
		//				value really returns and permanently
		//				return the destructed value 
		//				(it takes ~30 minutes to detect this issue)
		//
	char* ret = new char[LEN];
	char* s1  = new char[LEN];
	char* s2  = new char[LEN];

	int rev = 0;

	if (greater(ln.m_szam, m_szam)){
		strcpy(s2, m_szam);
		strcpy(s1, ln.m_szam);
		rev = 1;
	} else {
		strcpy(s1, m_szam);
		strcpy(s2, ln.m_szam);
	}
	strcpy(ret, "");
	strrev(s1);
	strrev(s2);
	if (strlen(s1) > strlen(s2)){

		while (strlen(s1) > strlen(s2)){
			strcat(s2, "0");
		}

	}
	if (strlen(s1) < strlen(s2)){

		while (strlen(s1) < strlen(s2)){
			strcat(s1, "0");
		}

	}

	int carry = 0;

	for (unsigned i = 0; i < strlen(s1); i++){
		int poz1 = 0;
		poz1 = (int)strchr( m_scl, (char)s1[i]);
		if (poz1 == NULL) {
			cout << endl << "hibs karakter" << endl;
			break;
		}
		poz1 -= (int)m_scl;
		int poz2 = (int)strchr( m_scl, (char)s2[i]); 
		if (poz2 == NULL) {
			cout << endl << "hibs karakter" << endl;
			break;
		}
		poz2 -= (int)m_scl;

		carry = carry + poz1 - poz2;

		strncat(ret, &m_scl[(strlen(m_scl) + carry) % strlen(m_scl)], 1);

		carry = abs(carry) / strlen(m_scl);
		carry = -carry;
	}

	if (carry == -1 && strlen(ret) < LEN - 1){
		rev = 1;								// biztosan legyen eljel
		strcat(ret,"1");
	}

	if (rev) strcat(ret,"-");					// odarakjuk az eljelet


	delete s1;
	delete s2;

	strrev(ret);

	return LongNum(ret);

}
//------------------------------------------------------
// Name: greater
// Desc: melyik a nagyobb sztring lexikografikusan
//------------------------------------------------------
bool LongNum::greater(const char* leftOp, const char* rightOp){
	if(strlen(leftOp) > strlen(rightOp)) return true;
	for (unsigned i = 0; i < strlen(rightOp); i++){
		if (leftOp[i] > rightOp[i]) return true;
		else 
		if (leftOp[i] == rightOp[i]) continue;
		else
		if (leftOp[i] < rightOp[i]) return false;
	}
	return false;	
}
//------------------------------------------------------
// Name: operator>
// Desc: nagyobb
//------------------------------------------------------
bool LongNum::operator>(const LongNum ln){
	return greater(m_szam, ln.m_szam);
}
//------------------------------------------------------
// Name: operator<
// Desc: kisebb
//------------------------------------------------------
bool LongNum::operator<(const LongNum ln){
// A ktfle megvalsts miatt kerlt bele 
// ez a mdszer
	if(strlen(m_szam) > strlen(ln.m_szam)) return true;
	for (unsigned i = 0; i < strlen(ln.m_szam); i++){
		if (m_szam[i] > ln.m_szam[i]) return false;
		else 
		if (m_szam[i] == ln.m_szam[i]) continue;
		else
		if (m_szam[i] < ln.m_szam[i]) return true;
	}
	return false;			
		// ez soha nem hajtdik vgre, de a 6.0-s
		// fordt jesllyel pampogna rte

}
//------------------------------------------------------
// Name: operator<<
// Desc: kiir (friend)
//------------------------------------------------------
ostream& operator<< (ostream& out, const LongNum ln){
	out << ln.m_szam;
	return out;
}