//------------------------------------------------------
// Name: MassSet.h
// Desc: pontszer testek trolsra szolgl halmaz
//       legyen a 0 tmeg pont nem ltez pont
// (c) RebelMaGE, 2004
//------------------------------------------------------
#include "MassSet.h"
//------------------------------------------------------
// Name: MassSet
// DESC: konstruktor
//------------------------------------------------------
MassSet::MassSet(UINT size){
	m_uiSize = size;
	m_aMasses = new Mass[m_uiSize];
	for (UINT i = 0; i < m_uiSize; i++){
		m_aMasses[i].m_imass = 0;
		m_aMasses[i].m_dx = 0.0f;
		m_aMasses[i].m_dy = 0.0f;
	}
}
//------------------------------------------------------
// Name: MassSet
// DESC: kopi konstruktor ide kell a & (!)
//------------------------------------------------------
MassSet::MassSet(const MassSet& m){
	m_uiSize = m.m_uiSize;
	m_aMasses = new Mass[m_uiSize];
	for (UINT i = 0; i < m_uiSize; i++){
		m_aMasses[i].m_imass = m.m_aMasses[i].m_imass;
		m_aMasses[i].m_dx = m.m_aMasses[i].m_dx;
		m_aMasses[i].m_dy = m.m_aMasses[i].m_dy;
	}
}
//------------------------------------------------------
// Name: ~MassSet
// DESC: destruktor
//------------------------------------------------------
MassSet::~MassSet(){
	if (m_aMasses) delete m_aMasses;
}
//------------------------------------------------------
// Name: tetaY
// DESC: Y tengelyte es forgatnyomatk (?)
//------------------------------------------------------
double MassSet::tetaY(){
	double sum = 0;
	for (UINT i = 0; i < m_uiSize; i++){
		sum += (m_aMasses[i].m_imass * pow(m_aMasses[i].m_dx,2));
	}
	return sum;
}
//------------------------------------------------------
// Name: operator +
// DESC: hozzad
//------------------------------------------------------
void MassSet::operator +(const Mass m){
	for(UINT i = 0; i < m_uiSize; i++){
		if (m_aMasses[i].m_dx == m.m_dx && m_aMasses[i].m_dy == m.m_dy){
			m_aMasses[i].m_imass += m.m_imass;
			return;
		}
	}
	for(UINT i = 0; i < m_uiSize; i++){
		if (m_aMasses[i].m_imass == 0){
			m_aMasses[i].m_imass = m.m_imass;
			m_aMasses[i].m_dx = m.m_dx;
			m_aMasses[i].m_dy = m.m_dy;
			return;
		}
	}

}
//------------------------------------------------------
// Name: operator +
// DESC: sszead ~~uni
//------------------------------------------------------
MassSet MassSet::operator +(const MassSet m){
	MassSet retVal(m_uiSize + m.m_uiSize);
	for (UINT i = 0; i < m_uiSize; i++){
		retVal.operator +(m_aMasses[i]);
	}
	for (UINT i = 0; i < m.m_uiSize; i++){
		retVal.operator +(m.m_aMasses[i]);
	}
	return retVal;
}
//------------------------------------------------------
// Name: operator *
// DESC: ~~metszet
//------------------------------------------------------
MassSet MassSet::operator *(const MassSet m){
	MassSet retVal((m_uiSize < m.m_uiSize) ? m_uiSize : m.m_uiSize);

	for (UINT i = 0; i < m_uiSize; i++)
		for (UINT j = 0; j < m.m_uiSize; j++){
			if (m_aMasses[i].m_dx == m.m_aMasses[j].m_dx && 
				m_aMasses[i].m_dy == m.m_aMasses[j].m_dy)
				retVal.operator +((m_aMasses[i].m_imass<m.m_aMasses[j].m_imass)?m_aMasses[i]:m.m_aMasses[j]);
		}

	return retVal;
}
//------------------------------------------------------
// Name: operator =
// DESC: rtkads
//------------------------------------------------------
void MassSet::operator=(const MassSet m){
	m_uiSize = m.m_uiSize;
	if (m_aMasses) delete m_aMasses;
	m_aMasses = new Mass[m_uiSize];
	for (UINT i = 0; i < m_uiSize; i++){
		m_aMasses[i].m_imass = m.m_aMasses[i].m_imass;
		m_aMasses[i].m_dx = m.m_aMasses[i].m_dx;
		m_aMasses[i].m_dy = m.m_aMasses[i].m_dy;
	}
}
//------------------------------------------------------
// Name: operator <<
// DESC: kiirats (friend)
//------------------------------------------------------
ostream& operator <<(ostream& out, MassSet m){
	for (UINT i = 0; i < m.m_uiSize; i++){
		if (m.m_aMasses[i].m_imass) 
			cout 
				<< "\tm: " << m.m_aMasses[i].m_imass
				<< "\tx: " << m.m_aMasses[i].m_dx
				<< "\ty: " << m.m_aMasses[i].m_dy
				<< endl;
	}
	return out;
}