//------------------------------------------------------
// Name: Prior.cpp
// Desc: Minimum prioritsi sor
//		 (!) de a kisebb a fontosabb (!)
//		 ezt is lehetne template -tel, de inkbb
//		 nem erltetem. gysenem lesz gyakzhn
// (c) RebelMaGE, 2004
//------------------------------------------------------
#include "Prior.h"
//------------------------------------------------------
// Name: Prior
// Desc: konstruktor
//------------------------------------------------------
Prior::Prior(){
	m_sor = NULL;
	m_size = 0;
}
//------------------------------------------------------
// Name: Prior
// Desc: konstruktor
//------------------------------------------------------
Prior::Prior(unsigned short size){
	m_size = size;
	m_sor = new SMyItem[m_size];
	for (UINT i = 0; i < m_size; i++){
		m_sor[i].m_prior = VEGTELEN;
		m_sor[i].m_progName = NULL;		
	}
}
//------------------------------------------------------
// Name: Prior
// Desc: kopi konstruktor
//------------------------------------------------------
Prior::Prior(const Prior& p){
	m_size = p.m_size;
	m_sor = new SMyItem[m_size];
	for (UINT i = 0; i < m_size; i++){
		m_sor[i].m_prior = p.m_sor[i].m_prior;
		if (p.m_sor[i].m_prior == VEGTELEN || p.m_sor[i].m_progName == NULL){
			m_sor[i].m_prior = VEGTELEN;
			m_sor[i].m_progName = NULL;
		} else {
			m_sor[i].m_progName = new char[strlen(p.m_sor[i].m_progName) + 1];
			strcpy(m_sor[i].m_progName, p.m_sor[i].m_progName);
		}
	}
}
//------------------------------------------------------
// Name: ~Prior
// Desc: destruktor
//------------------------------------------------------
Prior::~Prior(){
	if(m_sor) delete m_sor;
	m_sor = NULL;
	m_size = 0;
}
//------------------------------------------------------
// Name: add
// Desc: hozzad egy elemet a prior sorhoz
//		 ezt nem kne megcsinlni s tesztelni is kell
//------------------------------------------------------
int Prior::add(UINT prior, const char* progName){
	for (UINT i = 0; i < m_size; i++){
		if(m_sor[i].m_prior == VEGTELEN){
			if (progName){
				m_sor[i].m_progName = new char[strlen(progName + 1)];
				strcpy(m_sor[i].m_progName, progName);
			}else{
				m_sor[i].m_progName = NULL;
			}
			m_sor[i].m_prior = prior;
			return 1;
		}
	}
	return 0;
}
//------------------------------------------------------
// Name: szabadHely
// Desc: a mg szabad helyek
//------------------------------------------------------
UINT Prior::szabadHely(){
	return m_size  - foglaltHely();
}
//------------------------------------------------------
// Name: foglaltHely
// Desc: ez eddig lefoglalt helyek
//------------------------------------------------------
UINT Prior::foglaltHely(){
	UINT retVal = 0;
	for (UINT i = 0; i <m_size; i++){
		if (m_sor[i].m_prior != VEGTELEN) retVal++;
	}
	return retVal;
}
//------------------------------------------------------
// Name: echoInc
// Desc: kirja nvekv sorrendben a sort
//       tudom, nagyon butn van megvalstva, de 
//       hirtelen ez tnt a leggyorsabban 
//       megvalsthatnak
//------------------------------------------------------
void Prior::echoInc(){
	cout << endl << "novekvo sorrendben:" << endl;
	UINT maximal = 0;
	UINT minimal = VEGTELEN;
	UINT minimalhely = 0;
	for (UINT i = 0; i < m_size; i++){
		for (UINT j = 0; j < m_size; j++){
			if (VEGTELEN == m_sor[j].m_prior) continue;
			if (m_sor[j].m_prior < minimal && m_sor[j].m_prior > maximal){
				minimal = m_sor[j].m_prior;
				minimalhely = j;
			}
		}
		maximal = minimal;
		if (minimal != VEGTELEN)
			cout << m_sor[minimalhely].m_prior <<  "\t: " << m_sor[minimalhely].m_progName << endl;
		minimal = VEGTELEN;
	
	}
}
//------------------------------------------------------
// Name: echoDec
// Desc: kirja cskken sorrendben a sort
//       tudom, nagyon butn van megvalstva, de 
//       hirtelen ez tnt a leggyorsabban 
//       megvalsthatnak
//------------------------------------------------------
void Prior::echoDec(){
	cout << endl << "csokkeno sorrendben:" << endl;
	UINT maximal = 0;
	UINT minimal = VEGTELEN;
	UINT maximalhely = 0;
	for (UINT i = 0; i < foglaltHely(); i++){
		for (UINT j = 0; j < foglaltHely(); j++){
			if (VEGTELEN == m_sor[j].m_prior) continue;
			if (m_sor[j].m_prior > maximal && m_sor[j].m_prior < minimal){
				maximal = m_sor[j].m_prior;
				maximalhely = j;
			}
		}
		if (maximal == VEGTELEN) continue;
		minimal = maximal;
		cout << m_sor[maximalhely].m_prior <<  "\t: " << m_sor[maximalhely].m_progName << endl;
		maximal = 0;
	
	}
}
//------------------------------------------------------
// Name: operator+
// Desc: multihalmaz ni mvelet
//       (!) Figyelem (!)
//       Az op overloading ltalnos alakja:
//          MyClass operator+(const MyClsass);
//       s nem
//          MyClass& operator+(const& MyClsass mc);
//       (!)
//------------------------------------------------------
Prior Prior::operator+(const Prior p){
	Prior retVal(m_size + p.m_size);

	for (UINT i = 0; i < m_size; i++ )
		retVal.add(m_sor[i].m_prior, m_sor[i].m_progName);
	for (UINT i = 0; i < p.m_size; i++ )
		retVal.add(p.m_sor[i].m_prior, p.m_sor[i].m_progName);
	return retVal;
}
//------------------------------------------------------
// Name: operator*
// Desc: metszet ni mvelet
//       (!) Figyelem (!)
//       Az op overloading ltalnos alakja:
//          MyClass operator+(const MyClsass);
//       s nem
//          MyClass& operator+(const& MyClsass mc);
//       (!)
//------------------------------------------------------
Prior Prior::operator*(const Prior p){
	Prior retVal(m_size + p.m_size);

	for (UINT i = 0; i < m_size; i++ )
		for (UINT j = 0; j < p.m_size; j++ ){
			if (m_sor[i].m_prior == VEGTELEN || p.m_sor[j].m_prior == VEGTELEN) continue;
			if ( !strcmp(m_sor[i].m_progName, p.m_sor[j].m_progName ) &&
				m_sor[i].m_prior == p.m_sor[j].m_prior){

					retVal.add(p.m_sor[j].m_prior, p.m_sor[j].m_progName);
				}
		}
	return retVal;
}
//------------------------------------------------------
// Name: operator=
// Desc: rtktads mvelet
//------------------------------------------------------
void Prior::operator=(const Prior p){
	if (m_sor) delete m_sor;
	m_size = p.m_size;
	m_sor = new SMyItem[m_size];
	for (UINT i = 0; i < m_size; i++){
		m_sor[i].m_prior = p.m_sor[i].m_prior;
		if (!p.m_sor[i].m_progName){
			m_sor[i].m_progName = NULL;
		}else{
			m_sor[i].m_progName = new char[strlen(p.m_sor[i].m_progName + 1)];
			strcpy(m_sor[i].m_progName, p.m_sor[i].m_progName);
		}
	}
}
//------------------------------------------------------
// Name: operator<<
// Desc: kiirats mvelet
//------------------------------------------------------
ostream& operator<<(ostream& out,const Prior p){
	out << endl;
	for (UINT i = 0; i < p.m_size; i++){
		if (p.m_sor[i].m_prior < VEGTELEN)
			out << p.m_sor[i].m_prior << "\t: " << p.m_sor[i].m_progName << endl;
	}
	return out;
}
